import org.lekan.graphics.SGLine;


public class Edge {

private Node start;
private Node end;
private double cost;
	public Edge(Node start, Node end) {
		this.start = start;
		this.end = end;
		this.cost = Math.sqrt(Math.pow(start.getX(), 2) + Math.pow(start.getY(), 2));
		this.start.addEdge(this);
		this.end.addEdge(this);
	}

	public Edge(Node start, Node end, double cost) {
		this.start = start;
		this.end = end;
		this.cost = cost;
		this.start.addEdge(this);
		this.end.addEdge(this);
	}

	public SGLine getShape() {
		return new SGLine(start.getX(), start.getY(), end.getX(), end.getY());
	}
	
	public double getCost() {
		return cost;
	}
	
	public Node getStartNode() {
		return start;
	}
	
	public Node getEndNode() {
		return end;
	}

	public Node getOtherNode(Node node) {
		if (node.equals(start)) {
			return end;
		}
		if (node.equals(end)) {
			return start;
		}
		return null;
	}
}
