import java.util.ArrayList;

public abstract class Node {
	

protected ArrayList<Edge> edges;
protected int xPos;
protected int yPos;
protected int nodeIndex;
protected double cost;
protected Node previous;

	public Node() {
		edges = new ArrayList<Edge>();
	}
	
	public void addEdge(Edge e) {
		edges.add(e);
	}
	
	public ArrayList<Edge> getEdges() {
		return edges;
	}
	
	public int getX() {
		return xPos;
	}

	public int getY() {
		return yPos;
	}
	
	public int getNodeIndex() {
		return nodeIndex;
	}
	
	public double getCost() {
		return cost;
	}
	
	public Node getPrevious() {
		return previous;
	}

	public void setCost(double cost) {
		this.cost = cost;
	}
	
	public void setPrevious(Node previous) {
		this.previous = previous;
	}

	public ArrayList<Node> getNodes() {
		ArrayList<Node> nodes = new ArrayList<Node>();
		for (Edge edge : edges) {
			Node other = edge.getOtherNode(this);
			if (!other.equals(null)) {
				nodes.add(other);
			}
			else {
				System.err.println("node list error in getNodes() (this should never happen.)");
			}
		}
		return nodes;
	}
}
